# SPDX-FileCopyrightText: 2024 Zentrum für Digitale Souveränität der Öffentlichen Verwaltung (ZenDiS) GmbH
# SPDX-License-Identifier: Apache-2.0
---
- name: "Get groups"
  ansible.builtin.uri:
    url: "{{ global_keycloak_url }}/admin/realms/{{ global_opendesk_realm }}/groups"
    headers:
      Accept: "application/json"
      Authorization: "Bearer {{ global_accesstoken }}"
    method: "GET"
    status_code: [200]
  register: "groupsqueryresult"

- name: "Set group id for group {{ loop_group_name }} that should be 2FA enabled"
  ansible.builtin.set_fact:
    loop_group_id: "{{ groupsqueryresult['json'] | json_query('[?name==`'+loop_group_name+'`].id') | first }}"

- name: "Add mapping for group {{ loop_group_name }} / {{ loop_group_id }} to 2FA role {{ two_factor_role_name }} / {{ two_factor_role_id }}"
  ansible.builtin.uri:
    url: "{{ global_keycloak_url }}/admin/realms/{{ global_opendesk_realm }}/groups/{{ loop_group_id }}/role-mappings/realm"
    headers:
      Accept: "application/json"
      Authorization: "Bearer {{ global_accesstoken }}"
    body_format: "json"
    method: "POST"
    body: |
      [
        {
            "id": "{{ two_factor_role_id }}",
            "containerId": "{{ global_opendesk_realm }}",
            "clientRole": false,
            "composite": false,
            "name": "{{ two_factor_role_name }}"
        }
      ]
    status_code: [204, 409]
...
